# -*- coding:Utf-8 -*-
#!/usr/bin/python

# \copyleft Denis LE FUR \copyright
# This work may be distributed and/or mofified under the conditions
# or the LaTeX Project Public Licence, either v1.3 or (at your option)
# any later version. The latest version is in
#   http://www.latex-project.org/lppl/
# This work consists of the files TSQ.py.


import pygtk
pygtk.require("2.0")
import gtk  

import os
import sys
import platform

if platform.system()=="Linux" :
    sys.path.append("../SystemeLinux/")
else :
    sys.path.append("../SystemeWindows/")
from pro_sortie import *


sys.path.append("../Divers/")
from pro_divers import *
sys.path.append("../Supplements/Pro-tablor/")
from supp_tsq import *




class TSQ:



    #-------------------------------------------------------------
    # Initialisations, création de la fenêtre principale
    #-------------------------------------------------------------
    def __init__(self):
        interface = gtk.Builder()
        interface.add_from_file('TSQ.glade')

        self.entryNomFonction = interface.get_object("entryNomFonction")
        self.entryListeFacteursN = interface.get_object("entryListeFacteursN")
        self.entryListeFacteursD = interface.get_object("entryListeFacteursD")
        self.entryBorneGauche = interface.get_object("entryBorneGauche")
        self.entryBorneDroite = interface.get_object("entryBorneDroite")
        self.entryEchelle = interface.get_object("entryEchelle")
        self.checkbuttonEchelle = interface.get_object("checkbuttonEchelle")    
        self.checkbuttonTrigo = interface.get_object("checkbuttonTrigo")
        self.checkbuttonCouleurTableau = interface.get_object("checkbuttonCouleurTableau")  

        self.buttonCompiler = interface.get_object("buttonCompiler")
        self.progressbar = interface.get_object("progressbar")
        self.buttonCodeGraphique = interface.get_object("buttonCodeGraphique")
        self.buttonPdf = interface.get_object("buttonPdf")
        self.textviewCodeProfessor = interface.get_object("textviewCodeProfessor")
        self.textviewSupp = interface.get_object("textviewSupp")
        self.comboboxCouleur=interface.get_object("comboboxCouleur")
        
        
        #Indique si la compilation est lancée
        self.Etat_Compilation=False
        
        interface.connect_signals(self)
        self.maj_codeprofessor()
        maj_codesupp(self)
        
        self.textviewCodeProfessor.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse(couleurfond))
        self.textviewSupp.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse(couleurfond))
        
        #Couleur par défaut : noir
        self.comboboxCouleur.set_active(0)
        #désactivation
        self.comboboxCouleur.set_sensitive(False)
        self.entryEchelle.set_sensitive(False)
        #Donne le focus
        self.entryListeFacteursN.grab_focus()


    #-------------------------------------------------------------  
    # Fin de l'application  
    #-------------------------------------------------------------
    def on_windowTSQ_destroy(self, widget):
        gtk.main_quit()
        
        
    #-------------------------------------------------------------
    # Met à jour le code à insérer
    #-------------------------------------------------------------  
    def maj_codeprofessor(self):
        text_view=self.textviewCodeProfessor
        NomFonction=self.entryNomFonction.get_text()
        NomFonction=NomFonction.replace('\\','@')
        ListeFacteursN=self.entryListeFacteursN.get_text()
        ListeFacteursN=ListeFacteursN.replace('\\','@')
        ListeFacteursD=self.entryListeFacteursD.get_text()
        ListeFacteursD=ListeFacteursD.replace('\\','@')
        BorneGauche=self.entryBorneGauche.get_text()
        BorneGauche=BorneGauche.replace('\\','@')
        BorneDroite=self.entryBorneDroite.get_text()
        BorneDroite=BorneDroite.replace('\\','@')

        #-------------Fonction normale ou trigo 
        if self.checkbuttonTrigo.get_active():
            Trigo="t"
        else:
            Trigo="n"
        #------------traitement de la couleur du tableau
        if self.checkbuttonCouleurTableau.get_active():
            couleur=self.comboboxCouleur.get_active_text()
            if couleur=="Noir":
                Texte_Couleur=""
            elif couleur=="Rouge":
                Texte_Couleur="\\coultab{red}\n\n"
            elif couleur=="Vert":
                Texte_Couleur="\\coultab{green}\n\n"
            elif couleur=="Bleu":
                Texte_Couleur="\\coultab{blue}\n\n"
            elif couleur=="Gris":
                Texte_Couleur="\\coultab{(0.5,0.5,0.5)}\n\n"
        else:
            Texte_Couleur=""
        Texte_Code=Texte_Couleur
        
        #------------traitement de l'échelle
        if self.checkbuttonEchelle.get_active():
            echelle=self.entryEchelle.get_text()
            Texte_Echelle="\\ech{"+echelle+"}\n\n"
        else:
            Texte_Echelle=""
        Texte_Code=Texte_Code+Texte_Echelle
        
        
        #--------------Code principal : TS
        Texte_Code=Texte_Code+"\\begin{TSq}\n"
        Texte_Code=Texte_Code+"TSq(\""
        Texte_Code=Texte_Code+NomFonction+"\",["+ListeFacteursN+"],["+ListeFacteursD+"],["+BorneGauche+","+BorneDroite+"],"+Trigo+",\\tv)\n"
        Texte_Code=Texte_Code+"\\end{TSq}"
        ecrire_texte_textview(Texte_Code,text_view)
            



    #-------------------------------------------------------------
    # Mise à jour après des changements dans la définition du tableau
    #-------------------------------------------------------------      
    def on_entryNomFonction_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False

        
    def on_entryListeFacteursN_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryListeFacteursD_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryBorneGauche_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryBorneDroite_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
        
    def on_checkbuttonTrigo_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_checkbuttonCouleurTableau_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonCouleurTableau.get_active()==True:
            self.comboboxCouleur.set_sensitive(True)
        else:
            self.comboboxCouleur.set_sensitive(False)       
        self.Etat_Compilation=False 
    
    def on_checkbuttonEchelle_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonEchelle.get_active()==True:
            self.entryEchelle.set_sensitive(True)
        else:
            self.entryEchelle.set_sensitive(False)      
        self.Etat_Compilation=False
        
    def on_comboboxCouleur_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryEchelle_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False 
        


    #-------------------------------------------------------------
    # lancement de la compilation   
    #-------------------------------------------------------------  
    def on_buttonTester_pressed(self,widget):
        self.progressbar.set_text("en cours...")
        
    def on_buttonTester_released(self,widget):
        # création du fichier codeprofessor à partir du buffer
        text_buffer=self.textviewCodeProfessor.get_buffer()
        start_iter = text_buffer.get_start_iter()
        end_iter = text_buffer.get_end_iter()
        Texte=text_buffer.get_text(start_iter, end_iter, include_hidden_chars=True)
        ecrire_codeprofessor(Texte)
        # création du fichier codesupp à partir du buffer
        text_buffer=self.textviewSupp.get_buffer()
        start_iter = text_buffer.get_start_iter()
        end_iter = text_buffer.get_end_iter()
        Texte=text_buffer.get_text(start_iter, end_iter, include_hidden_chars=True)
        ecrire_codesupp(Texte)  
        ecrire_enteteprofessor("\\usepackage[xcas]{pro-tablor}")    
        compiler("mp")
        self.Etat_Compilation=True
        afficher("mp","Tab")
        self.progressbar.set_text("")
        
            
    #-------------------------------------------------------------
    # Affichage du code graphique   
    #-------------------------------------------------------------  
    def on_buttonCodeGraphique_clicked(self,widget):
        afficher_codegraphique("mp","Tab",self.Etat_Compilation)


    #-------------------------------------------------------------
    # Affichage du code graphique   
    #-------------------------------------------------------------  
    def on_buttonPdf_clicked(self,widget):
            afficher_imagepng("mp","Tab",self.Etat_Compilation)
        


            
#-------------------------------------------------------------          
#-------------------------------------------------------------      
# Boucle principale
#-------------------------------------------------------------
#-------------------------------------------------------------
if __name__ == "__main__":
    TSQ()
    gtk.main()

