# -*- coding:Utf-8 -*-
#!/usr/bin/python

# \copyleft Denis LE FUR \copyright
# This work may be distributed and/or mofified under the conditions
# or the LaTeX Project Public Licence, either v1.3 or (at your option)
# any later version. The latest version is in
#   http://www.latex-project.org/lppl/
# This work consists of the files TV.py.


import pygtk
pygtk.require("2.0")
import gtk  

import os
import sys
import platform

if platform.system()=="Linux" :
    sys.path.append("../SystemeLinux/")
else :
    sys.path.append("../SystemeWindows/")
from pro_sortie import *


sys.path.append("../Divers/")
from pro_divers import *
sys.path.append("../Supplements/Pro-tablor/")
from supp_tv import *




class TV:


    #-------------------------------------------------------------
    # Initialisations, création de la fenêtre principale
    #-------------------------------------------------------------
    def __init__(self):
        interface = gtk.Builder()
        interface.add_from_file('TV.glade')

        self.entryNomFonction = interface.get_object("entryNomFonction")
        self.entryNomVariable = interface.get_object("entryNomVariable")
        self.entryExpression = interface.get_object("entryExpression")
        self.entryBorneGauche = interface.get_object("entryBorneGauche")
        self.entryBorneDroite = interface.get_object("entryBorneDroite")
        self.entryValeursInterdites = interface.get_object("entryValeursInterdites")
        self.entryValeurIntermediaire = interface.get_object("entryValeurIntermediaire")
        self.entryEchelle = interface.get_object("entryEchelle")
        self.checkbuttonAfficheDerivee = interface.get_object("checkbuttonAfficheDerivee")
        self.checkbuttonEchelle = interface.get_object("checkbuttonEchelle")    
        self.checkbuttonTrigo = interface.get_object("checkbuttonTrigo")
        self.checkbuttonCouleurTableau = interface.get_object("checkbuttonCouleurTableau")  
        self.checkbuttonValeurIntermediaire = interface.get_object("checkbuttonValeurIntermediaire")
        self.checkbuttonCalculApproche = interface.get_object("checkbuttonCalculApproche")

        self.buttonCompiler = interface.get_object("buttonCompiler")
        self.progressbar = interface.get_object("progressbar")
        self.buttonCodeGraphique = interface.get_object("buttonCodeGraphique")
        self.buttonPdf = interface.get_object("buttonPdf")
        self.textviewCodeProfessor = interface.get_object("textviewCodeProfessor")
        self.textviewSupp = interface.get_object("textviewSupp")
        self.comboboxCouleur=interface.get_object("comboboxCouleur")
        
        
        #Indique si la compilation est lancée
        self.Etat_Compilation=False
        
        interface.connect_signals(self)
        self.maj_codeprofessor()
        maj_codesupp(self)
        
        self.textviewCodeProfessor.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse(couleurfond))
        self.textviewSupp.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse(couleurfond))
        
        #Couleur par défaut : noir
        self.comboboxCouleur.set_active(0)
        #désactivation
        self.comboboxCouleur.set_sensitive(False)
        self.entryEchelle.set_sensitive(False)
        self.entryValeurIntermediaire.set_sensitive(False)
        


    #-------------------------------------------------------------  
    # Fin de l'application  
    #-------------------------------------------------------------
    def on_windowTV_destroy(self, widget):
        gtk.main_quit()

    #-------------------------------------------------------------
    # Met à jour le code à insérer
    #-------------------------------------------------------------  
    def maj_codeprofessor(self):
        text_view=self.textviewCodeProfessor
        NomFonction=self.entryNomFonction.get_text()
        NomFonction=NomFonction.replace('\\','@')
        NomVariable=self.entryNomVariable.get_text()
        NomVariable=NomVariable.replace('\\','@')
        Expression=self.entryExpression.get_text()
        Expression=Expression.replace('\\','@')
        BorneGauche=self.entryBorneGauche.get_text()
        BorneGauche=BorneGauche.replace('\\','@')
        BorneDroite=self.entryBorneDroite.get_text()
        BorneDroite=BorneDroite.replace('\\','@')
        ValeursInterdites=self.entryValeursInterdites.get_text()
        ValeursInterdites=ValeursInterdites.replace('\\','@')
        ValeurIntermediaire=self.entryValeurIntermediaire.get_text()
        ValeurIntermediaire=ValeurIntermediaire.replace('\\','@')
        #------------Affichage de la ligne derivee
        if self.checkbuttonAfficheDerivee.get_active():
            AfficheDerivee="1"
        else:
            AfficheDerivee="0"
        #-------------Fonction normale ou trigo 
        if self.checkbuttonTrigo.get_active():
            Trigo="t"
        else:
            Trigo="n"
        #------------traitement de la couleur du tableau
        if self.checkbuttonCouleurTableau.get_active():
            couleur=self.comboboxCouleur.get_active_text()
            if couleur=="Noir":
                Texte_Couleur=""
            elif couleur=="Rouge":
                Texte_Couleur="\\coultab{red}\n\n"
            elif couleur=="Vert":
                Texte_Couleur="\\coultab{green}\n\n"
            elif couleur=="Bleu":
                Texte_Couleur="\\coultab{blue}\n\n"
            elif couleur=="Gris":
                Texte_Couleur="\\coultab{(0.5,0.5,0.5)}\n\n"
        else:
            Texte_Couleur=""
        Texte_Code=Texte_Couleur
        
        #------------traitement de l'échelle
        if self.checkbuttonEchelle.get_active():
            echelle=self.entryEchelle.get_text()
            Texte_Echelle="\\ech{"+echelle+"}\n\n"
        else:
            Texte_Echelle=""
        Texte_Code=Texte_Code+Texte_Echelle
        
        
        #--------------Code principal : TV
        if self.checkbuttonValeurIntermediaire.get_active()==False and self.checkbuttonCalculApproche.get_active()==False:
            Texte_Code=Texte_Code+"\\begin{TV}\n"
            Texte_Code=Texte_Code+"TV(["
            Texte_Code=Texte_Code+BorneGauche+","+BorneDroite+"],["+ValeursInterdites+"],\""+NomFonction+"\",\""+NomVariable+"\","+Expression+","+AfficheDerivee+","+Trigo+",\\tv)\n"
            Texte_Code=Texte_Code+"\\end{TV}"
            ecrire_texte_textview(Texte_Code,text_view)
            
        #--------------Code principal : TVapp
        if self.checkbuttonValeurIntermediaire.get_active()==False and self.checkbuttonCalculApproche.get_active()==True:
            Texte_Code=Texte_Code+"\\begin{TVapp}\n"
            Texte_Code=Texte_Code+"TVapp(["
            Texte_Code=Texte_Code+BorneGauche+","+BorneDroite+"],["+ValeursInterdites+"],\""+NomFonction+"\",\""+NomVariable+"\","+Expression+","+AfficheDerivee+",\\tv)\n"
            Texte_Code=Texte_Code+"\\end{TVapp}"
            ecrire_texte_textview(Texte_Code,text_view)
        #--------------Code principal : TVI
        if self.checkbuttonValeurIntermediaire.get_active()==True and self.checkbuttonCalculApproche.get_active()==False:
            Texte_Code=Texte_Code+"\\begin{TVI}\n"
            Texte_Code=Texte_Code+"TVI(["
            Texte_Code=Texte_Code+BorneGauche+","+BorneDroite+"],["+ValeursInterdites+"],\""+NomFonction+"\",\""+NomVariable+"\","+Expression+","+AfficheDerivee+","+ValeurIntermediaire+","+Trigo+",\\tv)\n"
            Texte_Code=Texte_Code+"\\end{TVI}"
            ecrire_texte_textview(Texte_Code,text_view)
            
        #--------------Code principal : TVIapp
        if self.checkbuttonValeurIntermediaire.get_active()==True and self.checkbuttonCalculApproche.get_active()==True:
            Texte_Code=Texte_Code+"\\begin{TVIapp}\n"
            Texte_Code=Texte_Code+"TVIapp(["
            Texte_Code=Texte_Code+BorneGauche+","+BorneDroite+"],["+ValeursInterdites+"],\""+NomFonction+"\",\""+NomVariable+"\","+Expression+","+AfficheDerivee+","+ValeurIntermediaire+",\\tv)\n"
            Texte_Code=Texte_Code+"\\end{TVIapp}"
            ecrire_texte_textview(Texte_Code,text_view)



    #-------------------------------------------------------------
    # Mise à jour après des changements dans la définition du tableau
    #-------------------------------------------------------------      
    def on_entryNomFonction_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryNomVariable_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryExpression_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryBorneGauche_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryBorneDroite_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryValeursInterdites_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_checkbuttonTrigo_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_checkbuttonAfficheDerivee_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_checkbuttonCouleurTableau_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonCouleurTableau.get_active()==True:
            self.comboboxCouleur.set_sensitive(True)
        else:
            self.comboboxCouleur.set_sensitive(False)       
        self.Etat_Compilation=False 
    
    def on_checkbuttonEchelle_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonEchelle.get_active()==True:
            self.entryEchelle.set_sensitive(True)
        else:
            self.entryEchelle.set_sensitive(False)      
        self.Etat_Compilation=False
    
    
    def on_checkbuttonValeurIntermediaire_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonValeurIntermediaire.get_active()==True:
            self.entryValeurIntermediaire.set_sensitive(True)
        else:
            self.entryValeurIntermediaire.set_sensitive(False)      
        self.Etat_Compilation=False
        
    def on_checkbuttonCalculApproche_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_comboboxCouleur_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
    
    def on_entryValeurIntermediaire_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryEchelle_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False 
        


    #-------------------------------------------------------------
    # lancement de la compilation   
    #-------------------------------------------------------------  
    def on_buttonTester_pressed(self,widget):
        self.progressbar.set_text("en cours...")
        
    def on_buttonTester_released(self,widget):
        # création du fichier codeprofessor à partir du buffer
        text_buffer=self.textviewCodeProfessor.get_buffer()
        start_iter = text_buffer.get_start_iter()
        end_iter = text_buffer.get_end_iter()
        Texte=text_buffer.get_text(start_iter, end_iter, include_hidden_chars=True)
        ecrire_codeprofessor(Texte)
        # création du fichier codesupp à partir du buffer
        text_buffer=self.textviewSupp.get_buffer()
        start_iter = text_buffer.get_start_iter()
        end_iter = text_buffer.get_end_iter()
        Texte=text_buffer.get_text(start_iter, end_iter, include_hidden_chars=True)
        ecrire_codesupp(Texte)  
        ecrire_enteteprofessor("\\usepackage[xcas]{pro-tablor}")    
        compiler("mp")
        self.Etat_Compilation=True
        afficher("mp","Tab")
        self.progressbar.set_text("")
        
            
    #-------------------------------------------------------------
    # Affichage du code graphique   
    #-------------------------------------------------------------  
    def on_buttonCodeGraphique_clicked(self,widget):
        afficher_codegraphique("mp","Tab",self.Etat_Compilation)


    #-------------------------------------------------------------
    # Affichage du code graphique   
    #-------------------------------------------------------------  
    def on_buttonPdf_clicked(self,widget):
            afficher_imagepng("mp","Tab",self.Etat_Compilation)
        


            
#-------------------------------------------------------------          
#-------------------------------------------------------------      
# Boucle principale
#-------------------------------------------------------------
#-------------------------------------------------------------
if __name__ == "__main__":
    TV()
    gtk.main()

